*---------------------------------------------------------------------------------------------
*
* gcc example2.s
* hex display board functional test
*
* 07/10/2021 steve crompton
*
*---------------------------------------------------------------------------------------------

    .global _start

    .text

    .equ hex_display,0xab0000

_start:

    move.l #0,%d0                   /* zero the counter */
    move.l #1,%d1                   /* set the counter step value */
    move.l #16,%d2                  /* set the switch digit count */

loop:

    move.l %d0,hex_display          /* display current count on the hex display */

    cmp.l %d0,%d2                   /* switch digit point reached? */
    bne.s no_switch

* switch digit

    asl.l #4,%d1                    /* 16x the counter step value */
    asl.l #4,%d2                    /* 16x the switch digit count */

no_switch:

    add.l %d1,%d0                   /* step the counter on */

    cmp.l #0,%d1                    /* all 8 digits done? */
    beq.s forever

* wait

    move.l #0x60000,%d3             /* set wait time */

delay:

    sub.l #1,%d3                    /* wait */
    bne.s delay

* wait end

    bra.s loop                      /* repeat */

forever:

*   bra.s forever                   /* wait for reset button to be pressed */

    move.b #228,%d7                 /* return to tutor monitor */
    trap #14

    .end

*---------------------------------------------------------------------------------------------
